#pragma region File Description
//--------------------------------------------------------------------------------------------------
// File : PixelBuffer.h
// Desc : Pixel Buffer Object
// Date : Dec. 01, 2008
// Version : 1.0
// Author : Pocol
//--------------------------------------------------------------------------------------------------
#pragma endregion

#ifndef __PIXEL_BUFFER_H_INCLUDED__
#define __PIXEL_BUFFER_H_INCLUDED__

#pragma region Includes
//
// Includes
//
#include <iostream>
#include <windows.h>
#include <GL/glew.h>
#include <GL/wglew.h>
#pragma endregion

#pragma region Link
//
// Link
//
#pragma comment ( lib, "glew32.lib" )
#pragma comment ( lib, "glew32s.lib" )
#pragma endregion

#pragma region PixelBuffer Class
////////////////////////////////////////////////////////////////////////
// PixelBuffer 
////////////////////////////////////////////////////////////////////////
class PixelBuffer
{
protected:
	HPBUFFERARB hPBuffer;
	HDC hDC;
	HGLRC hRC;
	int width;
	int height;
	GLuint handle;
	int exists;
	GLenum bound;

public:
	PixelBuffer( int w, int h, HDC hdc );
	~PixelBuffer();

	int Bind( GLenum drawBuffer = WGL_FRONT_LEFT_ARB );
	int Release();
	int MakeCurrent();

	GLuint GetTexture() { return handle; }
	HGLRC GetHRC() { return hRC; } 
	int Exist() { return exists; }
};
#pragma endregion

#endif // __PIXEL_BUFFER_H_INCLUDED__